// EmployeeSetView.cpp : implementation of the CEmployeeSetView class
//

#include "stdafx.h"
#include "EmployeeSet.h"

#include "EmployeeSetSet.h"
#include "EmployeeSetDoc.h"
#include "EmployeeSetView.h"
#include ".\employeesetview.h"
#include "FilterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CEmployeeSetView

IMPLEMENT_DYNCREATE(CEmployeeSetView, CRecordView)

BEGIN_MESSAGE_MAP(CEmployeeSetView, CRecordView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CRecordView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CRecordView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRecordView::OnFilePrintPreview)
	ON_COMMAND(ID_RECORD_ADDRECORD, OnRecordAddrecord)
	ON_COMMAND(ID_RECORD_DELETERECORD, OnRecordDeleterecord)
	ON_COMMAND(ID_RECORD_EDITRECORD, OnRecordEditrecord)
	ON_COMMAND(ID_SORT_DEPARTMENT, OnSortDepartment)
	ON_COMMAND(ID_SORT_ID, OnSortId)
	ON_COMMAND(ID_SORT_NAME, OnSortName)
	ON_COMMAND(ID_SORT_RATE, OnSortRate)
	ON_COMMAND(ID_FILTER_DEPARTMENT, OnFilterDepartment)
	ON_COMMAND(ID_FILTER_ID, OnFilterId)
	ON_COMMAND(ID_FILTER_NAME, OnFilterName)
	ON_COMMAND(ID_FILTER_RATE, OnFilterRate)
	ON_COMMAND(ID_FILTER_CLEAR, OnFilterClear)
	ON_COMMAND(ID_SORT_DESCENDINGNAME, OnSortDescendingname)
END_MESSAGE_MAP()

// CEmployeeSetView construction/destruction

CEmployeeSetView::CEmployeeSetView()
	: CRecordView(CEmployeeSetView::IDD)
	, m_bAdding(FALSE)
{
	m_pSet = NULL;
	// TODO: add construction code here

}

CEmployeeSetView::~CEmployeeSetView()
{
}

void CEmployeeSetView::DoDataExchange(CDataExchange* pDX)
{
	DDX_Text(pDX, IDC_EMPLOYEE_ID, m_pSet->m_EmployeeID);
	DDX_Text(pDX, IDC_EMPLOYEE_NAME, m_pSet->m_EmployeeName);
	DDX_Text(pDX, IDC_EMPLOYEE_RATE, m_pSet->m_EmployeeRate);
	DDX_Text(pDX, IDC_EMPLOYEE_DEPT, m_pSet->m_DeptID);
	CRecordView::DoDataExchange(pDX);
	// you can insert DDX_Field* functions here to 'connect' your controls to the database fields, ex.
	// DDX_FieldText(pDX, IDC_MYEDITBOX, m_pSet->m_szColumn1, m_pSet);
	// DDX_FieldCheck(pDX, IDC_MYCHECKBOX, m_pSet->m_bColumn2, m_pSet);
	// See MSDN and ODBC samples for more information
}

BOOL CEmployeeSetView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CRecordView::PreCreateWindow(cs);
}

void CEmployeeSetView::OnInitialUpdate()
{
	m_pSet = &GetDocument()->m_EmployeeSetSet;
	CRecordView::OnInitialUpdate();
}


// CEmployeeSetView printing

BOOL CEmployeeSetView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CEmployeeSetView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CEmployeeSetView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CEmployeeSetView diagnostics

#ifdef _DEBUG
void CEmployeeSetView::AssertValid() const
{
	CRecordView::AssertValid();
}

void CEmployeeSetView::Dump(CDumpContext& dc) const
{
	CRecordView::Dump(dc);
}

CEmployeeSetDoc* CEmployeeSetView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEmployeeSetDoc)));
	return (CEmployeeSetDoc*)m_pDocument;
}
#endif //_DEBUG


// CEmployeeSetView database support
CRecordset* CEmployeeSetView::OnGetRecordset()
{
	return m_pSet;
}



// CEmployeeSetView message handlers

void CEmployeeSetView::OnRecordAddrecord()
{
	m_pSet->AddNew();
	m_pSet->m_EmployeeRate = 0.0;
	m_pSet->m_EmployeeID = 0;
	m_bAdding = TRUE;
	CEdit* pCtrl = (CEdit*) GetDlgItem(IDC_EMPLOYEE_ID);
	int result = pCtrl->SetReadOnly(FALSE);
	UpdateData(FALSE);
}

void CEmployeeSetView::OnRecordDeleterecord()
{
	m_pSet->Delete();
	m_pSet->MoveNext();
	if (m_pSet->IsEOF()) {
		m_pSet->MoveLast();
	}
	if (m_pSet->IsBOF()) {
		m_pSet->SetFieldNull(NULL);
	}
	UpdateData(FALSE);
	m_pSet->Edit();
}

BOOL CEmployeeSetView::OnMove(UINT nIDMoveCommand)
{
	if (m_bAdding) {
		m_bAdding = FALSE;
		UpdateData(TRUE);
		if (m_pSet->CanUpdate()) {
			m_pSet->Update();
		}
		m_pSet->Requery();
		UpdateData(FALSE);CEdit* pCtrl = (CEdit*) GetDlgItem(IDC_EMPLOYEE_ID);
		pCtrl->SetReadOnly(TRUE);
		return TRUE;
	}
	return CRecordView::OnMove(nIDMoveCommand);
}

void CEmployeeSetView::OnRecordEditrecord()
{
	if (m_pSet->CanUpdate()) {
		m_pSet->Edit();
		UpdateData(TRUE);
		m_pSet->Update();
	}
}

void CEmployeeSetView::OnSortDepartment()
{
	SortByColumn("DeptID");
}

void CEmployeeSetView::OnSortId()
{
	SortByColumn("EmployeeID");
}

void CEmployeeSetView::OnSortName()
{
	SortByColumn("EmployeeName");
}

void CEmployeeSetView::OnSortRate()
{
	SortByColumn("EmployeeRate");
}

void CEmployeeSetView::OnFilterDepartment()
{
	FilterByColumn("DeptID");
}

void CEmployeeSetView::OnFilterId()
{
	FilterByColumn("EmployeeID");
}

void CEmployeeSetView::OnFilterName()
{
	FilterByColumn("EmployeeName");
}

void CEmployeeSetView::OnFilterRate()
{
	FilterByColumn("EmployeeRate");
}

void CEmployeeSetView::SortByColumn(CString strColumn, BOOL bOrder /*=TRUE*/)
{	
	CString strOrder = " DESC";
	if (bOrder) {
		strOrder = " ASC";
	}
	m_pSet->Close();
	m_pSet->m_strSort = strColumn + strOrder;
	m_pSet->Open();
	UpdateData(FALSE);
}

void CEmployeeSetView::FilterByColumn(CString strColumn)
{
	CFilterDlg dlg;
	dlg.m_bStringColumn = strColumn == "EmployeeName" || strColumn == "DeptID";
	if (dlg.DoModal() == IDOK) {
		CString strOp = " = ";
		if (dlg.m_bRegExp) {
			strOp = " LIKE ";
		}
		CString strFilter = dlg.m_strFilterValue;
		if (strColumn != "EmployeeRate" && strColumn != "EmployeeID") {
			strFilter = "'" + strFilter + "'";
		}
		strFilter = strColumn + strOp + strFilter;

		m_pSet->Close();
		m_pSet->m_strFilter = strFilter;
		m_pSet->Open();
		if (m_pSet->GetRecordCount() == 0) {
			AfxMessageBox("No Matching Records");
			OnFilterClear();
		}
		UpdateData(FALSE);
	}
}

void CEmployeeSetView::OnFilterClear()
{
	m_pSet->Close();
	m_pSet->m_strFilter = "";
	m_pSet->Open();
	UpdateData(FALSE);
}

void CEmployeeSetView::OnSortDescendingname()
{
	SortByColumn("EmployeeName", FALSE);
}
